#   2.3: 
#      
#        . 
vec1 <- c(2.298,2.805,3.031,2.378,1.676,1.91,2.95,3.479,3.305,2.142,2.786,2.377,0.369,1.421,1.877,
2.192,2.218,2.035,2.932,3.114,3.059,2.385,2.506,2.716,1.696,1.829,1.342,1.601,3.463,2.925,0.224,
2.833,2.899,2.822,2.708,1.829,2.049,0.523,3.096,2.426,0.991,2.735,1.129,2.303,1.889,2.497,0.715,
3.039,2.073,1.857,3.363)
vec2 <-c(2.865,3.183,2.752,2.866,0.918,0.946,1.19,1.585,4.026,2.583,3.605,4.035,3.88,3.74,1.807,
2.823,2.015,0.948,2.734,0.9,2.7,2.047,2.482,0.752,1.251,2.776,3.518,2.153,2.808,1.639,3.431,1.676,
2.873,2.733,3.778,2.999,1.607,2.645,2.104,3.628,2.089,2.377,3.475,1.933)
#    			 
#     t- ( P.Legendre, 2005)
t.stat <- function(n1,n2,vec1,vec2) {
moy1 <- mean(vec1) ; moy2 <- mean(vec2) ; var1 <- var(vec1) ; var2 <- var(vec2)
var.wm <- ( (n1-1)*var1 + (n2-1)*var2 ) / (n1+n2-2)
t <- ( moy1-moy2 ) / sqrt(var.wm * ((1/n1) + (1/n2)) )
return(list(moy1=moy1,moy2=moy2,var1=var1,var2=var2,stat=t))
}
#    
n1 <- length(vec1) ; n2 <- length(vec2) ; n  <- n1+n2 ; t.ref <- t.stat(n1,n2,vec1,vec2)
p1 <- pt(t.ref$stat,(n-2),lower.tail=TRUE) ; p2 <- pt(t.ref$stat,(n-2),lower.tail=FALSE)
p3 <- ifelse(p1 > p2, p2*2, p1*2)
c(cat(" :",n1,n2,"\n"), cat(" :",t.ref$moy1,t.ref$moy2,"\n"),
  cat(" :",t.ref$var1,t.ref$var2,"\n"), cat("t =",t.ref$stat,"  d.f. =",(n-2),"\n"),
  cat("  (t  )   = ",p1 ,"\n"),  
  cat("  (t  )   = ",p2,"\n"),
  cat("     = ",p3,"\n"))
#          R
t.test(vec1,vec2,var.equal=TRUE)
#    --
wilcox.test(vec1,vec2, conf.int = TRUE)
#                  
source("print_rezult.r")  #    
#  ,       
CompStat <- function (v1, v2, method = 1) {
if (method == 1) st <- t.stat(length(v1),length(v2),v1,v2)$stat #   
if (method == 2) st  <- sum(v1) -                            #   
if (method == 3) st <- median(v1) - median(v2)             #   
if (method == 4) st  <- mean(v1)/mean(v2)                  #   
return (st) }
#  ,        
simP <- function(vec1, vec2, permutations=5000, method=1) {
empar <- CompStat(vec1, vec2, method) ; boots <- numeric(permutations) ; vec <- c(vec1,vec2)
n1 <- length(vec1) ; n2 <- length(vec2) ; n  <- n1+n2
for (i in 1:permutations) {
#            
   vec.perm  <-  sample(vec,n) ;  vec1.perm <- vec.perm[1:n1] ;  vec2.perm <- vec.perm[(n1+1):n]
   boots[i] <- CompStat(vec1.perm, vec2.perm, method) }
return (RandRes (empar, boots, permutations)) }  #     
#     
simP(vec1, vec2,5000,1) ; simP(vec1, vec2,5000,2); simP(vec1, vec2,5000,3); simP(vec1, vec2,5000,4) 
#     
censor <- function (v, p.left=0, p.right=0.05) {
# : v  -  , p.left - ,  , p.right - ,  
v.c <- v
if (p.left>0) v.c <- v.c[which(v.c >= quantile(v, prob=p.left))]
if (p.right>0) v.c <- v.c[which(v.c <= quantile(v, prob=1-p.right))]
return (v.c) } 
#    ,   5% 
v.c1 <- censor(vec1, 0, 0.05) ; v.c2 <- censor(vec2, 0, 0.05) ; simP(v.c1, v.c2)
#    ,   25%   
v.c1 <- censor(vec1, 0.25, 0.25) ; v.c2 <- censor(vec2, 0.25, 0.25) ; simP(v.c1, v.c2)




