#   2.4: 
#     
source("print_rezult.r")  #    
#      (. 2.2)
bgw <- matrix(c(115.7,16.4,19.3,20.8,9.1,8.3,25.3,5.8,0.2,6.6,47.6,4.5,11.3,59.3,26.8,36.3,78.6,
223.8,102.3,70.7,41.1,29.5,18.8,34.5,12.6,5.5,9,49.3,3.9,8.8,54.1,8.7,8.3,49), 17, 2)
colnames(bgw) = c('1974-79', '1980-84')
n <- nrow(bgw)
#     --
wilcox.test(bgw[,1], bgw[,2], paired = TRUE)
#        t.test(...)
#   tail   c("two.sided", "less", "greater")
(res = t.test(bgw[,1], bgw[,2], paired=TRUE, alternative="two.sided"))
#----------------------
t.ref =  res$statistic  # t-   
#      
nperm <- 5000 ; vec.by.rows = as.vector(t(cbind(bgw[,1], bgw[,2]))) ; boots <- numeric(nperm)
for(i in 1:nperm) {
	vec.perm = rep(NA,2*n)
	for(j in 1:n) {
		i1 <- 2*(j-1)+1 ; i2 <- 2*j ; vec.perm[i1:i2] <- sample(vec.by.rows[i1:i2],2) }
	mat = matrix(vec.perm, n, 2, byrow=TRUE)
	res.perm = t.test(mat[,1], mat[,2], paired=TRUE, alternative="two.sided")
	boots[i]  = res.perm$statistic }
RandRes (t.ref, boots, nperm)
#----------------------
#        (Manly, 2007)
Permdiv <- function (d) { 
#   d  -        
#           
n <- length(d) ; nperm = 2^n 
if (n > 30)  {stop ("    ")}
sum.r <- sum.d <- sum(d) ; asum.d <- abs(sum.d); p <- as.numeric(rep(0,3))
for(j in 1:nperm)  {
  if (sum.r <= sum.d) p[1] <- p[1]+1
  if (sum.r >= sum.d) p[2] <- p[2]+1
  if (abs(sum.r) >= asum.d) p[3] <- p[3]+1
  for (i in 1:n)  if (j %% 2^(i-1) == 0) d[i] <- 0-d[i] 
  sum.r <- sum(d)  }
	p <- p/nperm
 c(cat("  B = ",nperm,"\n"), cat(" T(rand) < T(obs) P1 = ",p[1],"\n"),
  cat(" T(rand) > T(obs) P2 = ",p[2],"\n"),cat(" ABS(T(rand)) > ABS(T(obs)) P3 = ",p[3] ,"\n"))
}
Permdiv ( bgw[,1]-bgw[,2])

