#    2.8:
#    . -    
library(vegan) 		#   vegan
library(lattice)  ##  ,   
source("print_rezult.r")  #    
#         
load(file="_.RData") ; ls() ; TT
TT2S <- t(TT[,3:4]) ; TT2S <- TT2S[,colSums(TT2S)!=0] #       
#  ,     : 
#  ,    
div_est <- function (data, est = "shannon")
{ if (est == "shannon" | est == "simpson" )  diversity(data,est)
  else if (est == "rich")  sum(data>0) }
##  ,      
divdiff <- function(x) div_est(x[2, ]) - div_est(x[1, ])
# -------------------               
Nperm <-1000  #       
#       
div_est(TT2S[2, ]) ; div_est(TT2S[1, ]) ; d_emp <- divdiff(TT2S)
# ----------  -    oecosimu()
#  	1-  -  EE
#   ,       
rand.all <- function(dat) {
      dat.l<-length(dat[1,]) ; pool <- sample(c(dat[1,],dat[2,]),replace=F)
	dat[1,]= pool[1:dat.l]; dat[2,] = pool[(dat.l+1):(2*dat.l)]; dat }
(null.1 <- oecosimu(TT2S, divdiff, rand.all, nsim = Nperm))
#  	2-  -  FE1
#   ,      
#       
swap.row<- function(dat) {
 dat.l<-length(dat[1,]) ;  x<-round(runif(1,min=0, max=dat.l))
 if(x>0) tmp<-sapply(sample.int(dat.l, x, replace=FALSE), function(i) dat[,i]<<-rev(dat[,i]))
 dat  }
 (null.2 <- oecosimu(TT2S, divdiff, swap.row, nsim = Nperm))
#       
densityplot(null.2, xlab="       ", 
lwd=2,  ylab=" ") 
#  	4-  -  FF (r2dtable)
(null.3 <- oecosimu(TT2S, divdiff, "r2dtable", nsimul = Nperm))
# -------  -    permatfull ()
#   3-  -    FE2
d_rand <- rep(0,Nperm)  ; for (i in 1:Nperm) { 
x3 <- permatfull(TT2Sc, fixedmar = "columns", shuffle = "both" , times = 1)
TT_rand <- as.matrix(x3$perm[[1]]) ; d_rand[i] <- divdiff(TT_rand)  } 
RandRes (d_emp, d_rand , Nperm)
# -------         -
library(simboot)
TTS ; datspec = TTS[,-1] ; datspec = as.data.frame(t(datspec))
Variety <- as.factor(c(rep("",4),rep("_",5),rep("_",4)))
sbdiv(X = datspec, f = Variety, theta = "Shannon", type = "Tukey", method = "WYht",
 conf.level = 0.95,alternative = "two.sided", R = 2000)
sbdiv(X = datspec, f = Variety, theta = "Shannon", type = "Dunnett", method = "WYht",
 conf.level = 0.95, alternative = "two.sided", R = 2000, base = 2)
# M 
COUNTS<-as.matrix(datspec) ; rownames(COUNTS)<-Variety
COL<-grey(c(0,2,4,6,8,1,3,5,7)/8) #       
DMO<-COUNTS[,order(colSums(COUNTS), decreasing=TRUE)] ; DMO <- DMO[,1:33]
colnames(DMO)[15:33]<-"."  ; rownames (DMO)[c(2:4,6:9,11:13)]<-"*"  
par(mar=c(4,2,1,1)) ; mosaicplot(t(DMO), col=COL, las=2, off=15, main="", cex=1.1)
