#    3.3:
#      1-  2- 
#      ,     3.1
NDO <- c(88.9,94.9,70.8,46.4,31.0,66.5,83.6,71.9,59.6,22.5,29.2,6.5,17.5)
T <- c(14.8,14.5,11.5,12.6,12,14.5,13.3,16.7,16.9,20.6,21.2,22.5,22.4)
source("print_rezult.r")  #    
#       
Ex1 <-lm(NDO ~ T) ; Ex0 <-lm(NDO ~ 1) ; summary(Ex1); anova(Ex1, Ex0) 
#   F-      
F_obs <- anova(Ex1, Ex0)$F[2] ; b_obs <- Ex1$coefficients[2]
Nperm = 1000 ; F_rand <- b_rand <- as.numeric(rep(NA, Nperm))
for (i in 1:Nperm) { 
#    Y      
NDO_rerm <- sample(NDO,length(NDO)) ;  Ex_rand <- lm(NDO_rerm ~ T)    
F_rand[i] <- anova(Ex_rand)$F[1] ; b_rand[i] <- Ex_rand$coefficients[2] }
RandRes(F_obs, F_rand, Nperm) ;  RandRes(b_obs, b_rand, Nperm)  #    
#     
library(lmodel2)     #    ,    2-  
#    RMA-     .  999 
Ex2.res <- lmodel2(NDO ~ T, range.y= "relative",range.x="relative",nperm=999) ; Ex2.res 
#      4    
plot(Ex2.res, method="OLS", conf = FALSE, centroid=TRUE, main="",
 xlab = ", ", ylab = " ", col=1)
lines(Ex2.res, "SMA", col=2, conf = FALSE) ; lines(Ex2.res, "RMA", col=3, conf = FALSE)
lines(Ex2.res, "MA", col=4, conf = FALSE)   ; 
legend("topright", c("OLS", "SMA", "RMA", "MA"), col=1:4, lty=1)
#      4     ,    
op <- par(mfrow = c(2,2))  ; plot(Ex2.res, "OLS") ; plot(Ex2.res, "MA")
plot(Ex2.res, "SMA") ; plot(Ex2.res, "RMA") ; par(op)
library(MASS) ; summary(rlm(NDO ~ T))  #   
library(robustbase) ; lmrob(NDO ~ T)  #    LTS
#    b   
#   ,   ,   
boot_dist <- function(Nboot,x,y, function_name) { FUN <- match.fun(function_name);
  g <- FUN(y ~ x) ;   n=length(x);  bcoef <- as.numeric(rep(NA, Nboot))
for (i in 1:Nboot) {
newy <- g$fit + g$res[sample.int(n,size = n, replace=TRUE)] ; brg <- FUN(newy ~ x ) 
bcoef[i] <- brg$coef[2] }
  return (bcoef) }
bbLQ <- boot_dist(1000, T, NDO, "lm")
bbHu <- boot_dist(1000, T, NDO, "rlm")
bbLT <- boot_dist(1000, T, NDO, "lmrob")
#        . 3.5
plot(density(bbLQ),xlab=" b ", xlim=c(-14,0), main="", lwd=2)
abline(v=quantile(bbLQ,c(0.025,0.975)), lty=2) ; 
lines(density(bbHu),col="blue", lwd=2) ; abline(v=quantile(bbHu,c(0.025,0.975)), col="blue",lty=2)
lines(density(bbLT),col="red", lwd=2) ; abline(v=quantile(bbLT,c(0.025,0.975)),col="red",lty=2)
legend ("topleft", c("LSQ",  "Huber",  "LTS"),col = c("black","blue", "red"), lwd = 2)
