#    3.5:
#        
LUM<-read.table("lumbr.txt",header=TRUE,sep="\t") ; attach(LUM)
#        
dat <- data.frame(x=H, y=log(CHISL), f=factor(VARIANT))   #   ln  
summary(lm(y~x*f,data=dat)) ; anova(lm(y~x+f,data=dat),lm(y~x*f,data=dat))
#    t-.   b1  b2    p- 
test1 <- function(dat, fac=dat$f) {   fits <- lapply(split(dat,fac),lm,formula=y~x)
  sums <- lapply(fits,summary) ;   coefs <- lapply(sums,coef)
  db <- coefs[[2]]["x","Estimate"]-coefs[[1]]["x","Estimate"]
  sd <- sqrt(sum(sapply(coefs,function(x) x["x","Std. Error"])^2))
  df <- sum(sapply(fits,"[[","df.residual")) ;   td <- db/sd
  c(est=db, sd=sd, tstat=td, prt=2*pt(-abs(td),df))  }
#      ,     
test2 <- function(dat) {   fit <- lm(y~x*f,data=dat);   coef(summary(fit))["x:f2",]}
rbind(test1(dat),test2(dat))   #        df
#  ,      p-
source("print_rezult.r") ; testPerm <-  function(dat, Nperm=1000)  {
  PermArray <- as.numeric(rep(NA, Nperm)) ;  for (i in 1:Nperm) #    
  PermArray[i] <- test1(dat,sample(dat$f))[3] ; return (RandRes(test1(dat)[3], PermArray, Nperm)) }
testPerm(dat)
#   ,        :
dat <- data.frame(x=H, y= BM, f=factor(VARIANT))   #    -  
dat <- data.frame(x=H, y=log(BM), f=factor(VARIANT))   #  ln  
dat <- data.frame(x=H, y=sqrt(CHISL* BM), f=factor(VARIANT))   #   
dat <- data.frame(x=H, y=log(sqrt(CHISL* BM), f=factor(VARIANT)))   # ln   
#   -----------------------------------------------------------
#         
df1 <- data.frame( x=H[VARIANT==1], y=log(CHISL[VARIANT==1])) #  
df2 <- data.frame(x=H[VARIANT==2], y=log(CHISL[VARIANT==2]))  #  
xin <- seq(0.9*min(H), 1.1*max(H), length=100) ; fit1 <- lm(y~x, df1); fit2 <- lm(y~x, df2)
pre1 <- predict(fit1, data.frame(x=xin), interval="confidence")
pre2 <- predict(fit2, data.frame(x=xin), interval="confidence") ; pre <- data.frame(pre1, pre2)
plot(df1, pch=16, cex=0.7, col="red"); points(mean(df1$x), mean(df1$y), pch=11)
points(df2, pch=17, cex=0.7, col="blue"); points(mean(df2$x), mean(df2$y), pch=11)
matplot(xin,pre,type="l",lty=c(1,2,2,1,3,3), lwd=c(2,1,1,2,1,1), col= c(2,2,2,4,4,4), add=TRUE)
source("Kendall_Theil_Regr.r")    #     -
 (Res1 <- Kendall(df1)) ; (Res2 <- Kendall(df2))
plot(df1,type="p",cex=0.7, col="red",pch=16) ; points(df2, pch=17, cex=0.7, col="blue")
curve(Res1[1,1]*x+Res1[4,1], add=TRUE, col="red", lwd=2)
curve(Res2[1,1]*x+Res2[4,1], add=TRUE, col="blue", lwd=2)
#   ,        
