#    4.3:
#       " "
####   LM      LMEM
#     
data1=read.table("Orto_Bal.txt",header=T,sep="\t")  #       
#        
data2=read.table("Orto_Full.txt",header=T,sep="\t")  #    
###    (1)  (3)
model1=lm(Adjus _Orto~Water*GroundType+RiverType,data1) ; anova(model1)
model3=lm(log(Orto+1)~Water*GroundType+RiverType+Season,data2,family = poisson)
summary(model3) ; anova(model3, test="Chi")
###      (1)  (3)
Nrep=1000            #     
#   -      
#  mod_full -  ; mod_m1 -     
P_value <- function (mod_full, mod_m1, data) {   lrsl = matrix(0,Nrep)
#    
f_full <- as.formula(paste("sim_m1 ~",strsplit(as.character(formula(mod_full)),"~")[3]))
f_m1 <- as.formula(paste("sim_m1 ~",strsplit(as.character(formula(mod_m1)),"~")[3]))
for (i in 1:Nrep)   { sim_m1 = unlist(simulate(mod_m1))  #      
#         
     smod_full=lmer(formula = f_full,data) ;       smod_m1=lmer(formula = f_m1,data)
#   -    
     lrsl[i]= 2*(logLik(smod_full)-logLik(smod_m1))[1] }
#         
thresh <- 2*(logLik(mod_full)-logLik(mod_m1))[1]
return (mean(lrsl>thresh)) }
# ---------------------------------------------------------------------
###   (2),  (1|factor)   
Model2=lmer(Adjus_Orto~Water*GroundType+(1|RiverType),data1)
###     
Model2_1=lmer(Adjus_Orto~Water+GroundType+(1|RiverType),data1)
###      Water  GroundType
Model2_2=lmer(Adjus_Orto~Water+(1|RiverType),data1)
Model2_3=lmer(Adjus_Orto~GroundType+(1|RiverType),data1)
#    -   LRT- 
P_value(model2, model2_1, data1) ; 2*(logLik(model2)-logLik(model2_1))[1]
P_value(model2_1, model2_2, data1) ; 2*(logLik(model2_1)-logLik(model2_2))[1]
P_value(model2_1, model2_3, data1) ; 2*(logLik(model2_1)-logLik(model2_3))[1]
###   (4)      
Model4=lmer(log(Orto+1)~Water*GroundType + (1 | RiverType) + (1 | Season),data2) ; anova(model0)
#         
model4_1 =lmer(log(Orto+1)~Water + GroundType + (1 | RiverType) + (1 | Season),data2)
model4_2 =lmer(log(Orto+1)~Water + (1 | RiverType)+ (1 | Season) ,data2)
model4_3 =lmer(log(Orto+1)~GroundType + (1 | RiverType) + (1 | Season),data2)
#    -   LRT- 
P_value(model4, model4_1, data2) ; 2*(logLik(model4)-logLik(model4_1))[1]
P_value(model4_1, model4_2, data2) ; 2*(logLik(model4_1)-logLik(model4_2))[1]
P_value(model4_1, model4_3, data2) ; 2*(logLik(model4_1)-logLik(model4_3))[1]
