#    5.1:
#   /   
source("similary.r")   #          x-y
source("print_rezult.r")  #    
#   -----------    -  bootN   
simci <- function(data , bootN, method) 
 { boots <- numeric(bootN)   #      
          vyb <- replicate(bootN, sample.int(ncol(data), replace=TRUE)) 
          boots <- sapply(1: bootN, function (i) {l<-vyb[,i]; similary(data[,l],method=method)})
  return (BootRes(boots, similary(data,method=method))) }  #  
#   
TT <- read.table("Dis.txt",header=T,sep="\t")  #        y
TS <- t(TT) #    (  ,   )
simci(TS,1000,4) ; simci(TS,1000,5) ; simci(TS,1000,6)   #      
simci(TS,1000,1) ; simci(TS,1000,2) ; simci(TS,1000,3)   #     
#   -----------      permutations   
simP <- function(data , permutations, method) 
 { empar <- similary(data,method=method) ; boots <- numeric(permutations) 
for (i in 1:permutations) 
#       y     
boots[i] <- similary(rbind(data[1,], sample(data[2,], replace=FALSE)),method=method)
return (RandRes (empar, boots, permutations)) }  #     
#     
simP(TS,1000,4) ; simP(TS,1000,5) ; simP(TS,1000,6)   #      
#     ,   ,   
#            T, 
#      -  ,    -  
library (vegan)
specpool(T, index = "jack1")  #      1
#  :  d = 115
#         115    
TSD <- cbind(TS, matrix(replicate(230,0), nrow=2))
simP(TSD,1000,1) ; simP(TSD,1000,2) ; simP(TSD,1000,3)   #     
