#  	  5.6:
#    
#  -------------     fanny.  . 
#    . .  http://cafedra.narod.ru/solondaev/solond-R-fanny.pdf
#        A.norm  spe.ch,    5.4
#        A.norm  spe.ch,    5.4
A <- read.xls("1.xls", sheet = 1, rowNames=TRUE) ; A[is.na(A)] <- 0 ; library (vegan)
A.norm <- decostand(t(A), "normalize"); spe.ch <- vegdist(A.norm, "euc")
#       -   
Z1.f <- fanny(A.norm, 3, metric = "SqEuclidean", diss=FALSE) ; clusplot(Z1.f)
#      ,    5.4
Z2.f <- fanny(spe.ch, 3, memb.exp = 1.5) ; clusplot(fanny(Z2.f,labels= 3, col.clus="gray11")
#  -------------      fso () .  . 
#   .  http://ecology.msu.montana.edu/labdsv/R/labs/lab11/lab11.html
#            
 veg <- read.table("bs_ben.txt",header=T, sep="\t")
 site <- read.table("bs_site.txt",header=T,sep="\t") ;  attach(site)
 source("abundsim.R")  #       
 sim <- sim.abund(veg,method=2)  ;  dis.ho <- 1 - sim 
 grads.fso <- fso(~~hg+Ss+v+h+O2+P_min+NO2+BO+pH+KG+IP+t,dis.ho,permute=1000)
 summary(grads.fso)  #     FSO
grads.t <- fso(t,dis.ho) ; plot(grads.t) ;  plot(grads.t,dis.ho)
#      FSO 
step.mfso(dis.ho,start=data.frame(t),add=data.frame(pH,h,hg,NO2,KG,IP))
#      FSO 
grads.mfso <- mfso(~~t+h+NO2+pH,dis.ho, scaling=2,permute=1000) ;  summary(grads.mfso)
