#  	  5.7:
##       (Petchey, Gaston 2002)
##   .  http://www.ieu.uzh.ch/petchey/Code/code.html
source("Xtree.r")   ##     ,    
##   ----------------  
library(xlsReadWrite); library(vegan)
SP <- read.xls(" .xls",sheet = 3, rowNames=TRUE)  #    
TS <- read.xls(" .xls",sheet = 2, rowNames=TRUE)  #     
#          
TS_norm <- decostand(TS,"standardize") ;  species.traits <- as.matrix(SP)%*%as.matrix(TS_norm)
#       
community.composition <- read.xls(" .xls",sheet = 1, rowNames=FALSE)
Distance.method <- "euclidean" ; Cluster.method <- "average" ; distances <- dist(species.traits) 
tree <- hclust(distances) ; xtree <- Xtree(tree) ; FD_2 <- Getlength(xtree, community.composition)
rownames(FD_2)<- c("_01","_02","_03","_04","_05","_08","_10","_12","_14")
#        
attach(FD_2); fit <- lm(FD.new ~ S); summary(fit) ; x <- seq(0.9*min(S), 1.1*max(S), len=100)
pre <- predict(fit, data.frame(S=x), interval="confidence")
plot(FD_2,xlab=" ", ylab=" ")
text(FD_2, row.names(FD_2), cex=1, pos=3) ; matplot(x, pre, type="l", lty=c(1,2,2), add=TRUE)
#     FD      
TTB.Coor <- data.frame(c(9789,9397,9068,8385,7734,4347,2715,1429,500),
c(3207,3324,3023,2778,2777,2193,1628,694,300)) ; colnames(TTB.Coor)<- c("X","Y")
plot(TTB.Coor, asp=1,  pch=21, col="white", bg="grey30", cex=8* FD.new/max(FD.new))
lines(TTB.Coor, lwd=2, col="blue") ; text(TTB.Coor, row.names(FD_2), cex=0.5, col="white")
