#    6.3:      
# 1.   
#         
library(vegan)  ; load(file="Fito_Full.RData");  Species <- Species[,-8]
#        
Env <- Fito_Full[,27:36] ; rankindex(scale(Env), Species, c("euc","man","bray","jac","kul"))
spe.bray <- vegdist(Species) 		 # PCoA   - 
spe.b.pcoa <- cmdscale(spe.bray, k=(ncol(Species)), eig=TRUE)
spe.b.wa <- wascores(spe.b.pcoa$points[,1:2], Species)
#      
ordiplot(scores(spe.b.pcoa)[,c(1,2)], type="n", ylim=c(-0.4,0.4)) ; abline(h=0, lty=3);abline(v=0, lty=3)
ordipointlabel(spe.b.wa, display = "sp", font=4,  pch=21, cex=0.7, bg="grey")
with(Env, ordisurf(spe.b.pcoa, H, add = TRUE, col = "green4"))
with(Env, ordisurf(spe.b.pcoa, Sum_all, add = TRUE, col = "red"))
# 2.    (NMDS)
library(xlsReadWrite)  #      Excel  
A <- read.xls("1.xls", sheet = 1, rowNames=TRUE)
A[is.na(A)] <- 0 ; A.norm <- decostand(t(A), "normalize")
#     NMDS-        
ben.mds <- metaMDS(A.norm, trace = FALSE)  ;  gof <- goodness(ben.mds)
#      ,    
plot(ben.mds, type = "t", disp="sites", font=2) ; points(ben.mds, disp="sites",cex=6*gof/mean(gof))
#     NMDS       
pro <- procrustes(ben.mds, rda(A.norm, scale=FALSE))
plot(pro) ; points(pro, display= "rotated") ; text(pro, display= "target")
# 3.  
#    
Env <- read.xls("1.xls", sheet = 2, rowNames=TRUE) ; Env.stand<-decostand(Env,"standardize")
#              
bentos.ca <- cca(A.norm) ; (ef <- envfit(bentos.ca, Env.stand, permutations = 999))
plot(bentos.ca,  type="n") 		#   
ordipointlabel(bentos.ca, display = "site", font=2,  pch=21, cex=0.7, bg="grey")
ordilabel(bentos.ca, dis = "sp", cex=0.7, font=3 ,add = TRUE) ; plot(ef, cex=1.2,  col = "red", lwd=2)
#       1
ord9.rda <- rda(formula = A.norm ~ hg  + t + h + O2 + P_min + NO2 + pH + KG + IP, data = Env.stand)
RsquareAdj(ord9.rda)$adj.r.squared   ; RsquareAdj(ord9.rda)$r.squared    ;    anova(ord9.rda, step=1000)
anova(ord9.rda,by = "terms", step=1000) ; anova(ord9.rda,by = "axis", step=1000)  
#          
library(packfor); forward.sel(A.norm, Env.stand)
ord.all <- rda(A.norm ~., data = Env.stand) ; ord.0   <- rda(A.norm ~ 1, data=Env.stand)
ordistep(ord.0, scope = formula(ord.all), pstep = 1000)
step(ord.0, scope = formula(ord.all), test = "perm", steps = 1000)
ord3.rda <- rda(formula = A.norm ~  t + IP + Ss, data = Env.stand)  #    2
ord1.rda <- rda(formula = A.norm ~  t, data = Env.stand)                  #    3
#    2  3     anova,     1
