#    6.5:      
load(file="Fito_Full.RData");  Species <- Species[,-8] ; Env <- Fito_Full[,27:36]
library(mvpart) ; library(rpart.plot) ; library(labdsv) ; library(indicspecies)
#     mvpart      (. 4)
spe.mvpart <- mvpart(data.matrix(Species) ~ ., Env, margin=0.08, cp=0, 
	xv="pick", xval=nrow(Species), xvmult=100, which=4, bars = FALSE)
plot(spe.mvpart) ; text(spe.mvpart) ; summary(spe.mvpart) ; printcp(spe.mvpart)
prp(spe.mvpart, extra=5)  #     
(groups.mrt <- levels(as.factor(spe.mvpart$where)))
leaf.sum <- matrix(0, length(groups.mrt), ncol(Species))  #     
colnames(leaf.sum) <- colnames(Species)
for(i in 1:length(groups.mrt)){
  leaf.sum[i,] <- apply(Species[which(spe.mvpart$where==groups.mrt[i]),], 2, sum)}  ; leaf.sum
#     " "
par(mfrow=c(2,5)) ; for(i in 1:length(groups.mrt)){
	pie(which(leaf.sum[i,]>0), radius=1, main=c(".  ", groups.mrt[i])) }
#     IndVal
spe.MRT.indval <- indval(Species, spe.mvpart$where) ; spe.MRT.indval$pval    # P-
spe.MRT.indval$maxcls[which(spe.MRT.indval$pval<=0.05)]  #    max[d] 
spe.MRT.indval$indcls[which(spe.MRT.indval$pval<=0.05)]    #    IndVal    <0.05
#     IndVal
Ind.spe <- strassoc(Species, spe.mvpart$where, func="IndVal.g", nboot = 1000)
Ind.spe$stat^2 ; Ind.spe$lowerCI^2 ; Ind.spe$upperCI^2 


