#      7.2:
#    ,     
load(file="time_ser.RData")
#         
acf(WIND.repl) ;   Box.test(WIND.repl, lag=12, type="Ljung-Box")
ccf(WIND.speed,WIND.repl,lag.max=12) #   -  
#   (13)    
lag=14 ; ac_emp <- acf(WIND.repl,plot = F,lag.max=lag-1)$acf ; N_rand=1000 
 ac_rand = matrix(rep(0,N_rand*lag), ncol=lag)  ; for (i in 1:N_rand) { 
ac_rand[i,] <- acf(ts(sample(WIND$), frequency=12, start=c(1961,1)),
plot = F,lag.max=lag-1)$acf }
p <- rep(0,lag) ; for (j in 1:lag) { p[j] <- (sum(abs(ac_rand[,j])- abs(ac_emp[j]) >= 0)+1)/(N_rand+1) }
print(cbind(ac_emp, p),3) 
library(forecast) ; monthplot(WIND.repl,ylab=", %",xlab="",xaxt="n", type =  "h")
axis(1,at=1:12,labels=month.abb,cex=0.8)  #    
#            -    (   )
library(forecast) ; WIND.repl.DF <- adf.test(WIND.repl, alternative = "stationary")
source("DF.r")  ; adf.test.1(WIND.repl,kind=3, k=12)
adf.test.1(WIND.speed,kind=3, k=12) ; adf.test.1(FLOW,kind=3, k=12) 
#               
spec.pgram(FLOW, spans=3, log="no") ; spec.pgram(WIND.speed, spans=3, log="no")
spec.pgram(WIND.repl, spans=3, log="no")
#   g-      
library(GeneCycle) ; t=1:length(WIND$) ; fisher.g.test(WIND.repl)      
y = robust.spectrum(x=WIND.repl,t=t, algorithm="regression")
pvals = robust.g.test(y = y, perm=TRUE, x=as.matrix(WIND.repl), noOfPermutations = 50, 
algorithm = "regression", t=t)
#          
Cycle.Per <- function (X ,N=length(X), NRAND=100) {
#  : W  -   , CYCLE -     
# P  P0 -        
# SIGP -   (%  ,  )
#  SKS  SIGKS -  -     
NS = N%/%2 ; N = 2*NS ; XS <- scale(X) ; PLE <- Period(XS[1:N],N)
SIGKS=1 ; SIGP <- rep(1,NS) ; P0 <- rep(0,NS) ; W = (1:NS)*2*pi/N ; CYCLE = N/(1:NS)
for (ira in 2:NRAND) { PLR <- Period(sample(XS, N), N)  
if (PLR$SKS > PLE$SKS) SIGKS = SIGKS + 1 
SIGP[which(PLR$P > PLE$P)] + 1 -> SIGP[which(PLR$P > PLE$P)]; P0 <- P0 + PLR$P }
tab.per <- data.frame(W=W,CYCLE=CYCLE,P=PLE$P,P0=P0/NRAND,SIGP=SIGP,
 SIGPP=SIGP/NRAND)
return(list(Period=tab.per,SKS=PLE$SKS,SIGKS=SIGKS/NRAND)) }
cos.per <- function (N, M, i, k){return(ifelse(k==M, (-1)^i/N, cos(2*pi*k*i/N)/M))}
sin.per <- function (N, M, i, k){return(ifelse(k==M, 0, sin(2*pi*k*i/N)/M))}
Period  <- function (XS ,N) {
# : P  -   ,    
# SKS   -  -
M=N/2 ; S2 <- P <- A <- B <- rep(0,M) 
for ( i in 1:N) { 
    for ( k in 1:M) {
         A[k] + XS[i]*cos.per(N, M, i, k)  -> A[k]
         B[k] + XS[i]*sin.per(N, M, i, k)  -> B[k] }
}
S2 <- A*A+B*B; P = S2/2; P[M]=A[M]*A[M] ; U <- cumsum(S2[1:M-1]/sum(S2[1:M-1])); DMAX <- 0
for ( k in 1:M-1) DMAX <- max(c(DMAX, k/(M-1) - U[k], U[k] - (k-1)/(M-1))) 
return(list(P=P,SKS=DMAX)) }  
#       
Per.Repl <- Cycle.Per(WIND$, NRAND=500)
plot (Per.Repl$Period[,1], Per.Repl$Period[,3],"l")
lines(Per.Repl$Period[,1], Per.Repl$Period[,4], lwd=2, col="green") 


