#      7.4:
#          
M8 <- read.table("time_6.txt",header=TRUE) ; M4 <- M8[, c(1,5,3,4)]
month_l = rep(5:10,nrow(M4)%/%6) ; M4.s <- transform(scale(M4),month = month_l)
#  1.     
M4.ss <- M4.s[order(M4.s$month),] ; attach(M4.ss)
plot(M4.ss[,c(5,1)], type="n", ylim=c(-1,1.5), xlab=" ", ylab=" .")
for (i in 1:4)  { lines(month, predict(loess(M4.ss[,i]~month), data.frame(month=month)),lwd=2, col = i)}
legend ("topright", c("",  "", " NH4", ""),col = c(1:4),lwd=2)
#       
lag.ts.matrix <- function(ts,order) {
  n <- length(ts);  x <- ts[(order+1):n]
  for (lag in 1:order) { x <- cbind(x,ts[(order+1-lag):(n-lag)])}  
colnames(x) <- c("lag0",paste("lag",1:order,sep="")) 
 return(as.data.frame(x)) }
#    
#    rda()  prcomp(),     
pca <- function(x, scale=T, center=T, proj=T) {
  nobs <- nrow(x);  nvars <- ncol(x); x <- scale(x, scale=scale, center=center)
  s <- svd(x/sqrt(nobs-1)) ; pca.lst <- list(Evals=s$d^2, Loadings=t(t(s$v)*s$d))
  if(proj) pca.lst$Projections <- t(t(s$u)*s$d)*sqrt(nobs-1)
  names(pca.lst$Evals)       <- paste(" ",1:nvars,sep="")
  dimnames(pca.lst$Loadings) <- list(colnames(x),paste(" ",1:nvars,sep=""))
  if(proj) dimnames(pca.lst$Projections) <- list(rownames(x),paste(" ",1:nvars,sep=""))
  for(j in 1:nvars)
    if(sum(pca.lst$l[,j]) < 0    { pca.lst$Loadings[,j] <- -pca.lst$Loadings[,j];
        if(proj) pca.lst$Projections[,j] <- -pca.lst$Projections[,j] }  
  pca.lst }
#    
L5.CAL <- lag.ts.matrix(M4[,1],5) ; pca.l <- pca(L5.CAL); pca.l$Loadings
pca.l$Evals; cumsum(pca.l$Evals[1:6]/sum(pca.l$Evals))
plot(pca.l$Projections[,c(1,2)], type="n" )
lines(pca.l$Projections[,c(1,2)]) ; text(pca.l$Projections[,c(1,2)],labels= 6:108, cex=0.7, font=4)
#  2.      
W.decomp <- ts(M4,frequency = 6,start = c(1961,1)) ; M4.t <- M4
for (i in 1:4) {M4.t[,i] <-  decompose(W.decomp[,i])$trend}
pca.t <- pca(M4.t[4:105,]) ; pca.t$Evals; cumsum(pca.t$Evals[1:4]/sum(pca.t$Evals))
plot(M8[4:105,2], pca.t$Projections[,1], type="l", lwd=2)
abline(lm(pca.t$Projections[,1]~M8[4:105,2]),col="red", lwd=2)
lines(M8[4:105,2], pca.t$Projections[,2], lty=2)


