#    1.4:
#       -.
#    (   )   
T <- read.delim("Species.txt") ; x <- T$S ; n = length(x)
summary(x)  #      
#     -    
library(car) ; qqPlot(x, dist= "norm",xlab="  ", 
     ylab=" ", main="", pch=19)
#       c,, -  -
library(nortest) ;  lillie.test(x) ; pearson.test(x) ;  shapiro.test(x) ; cvm.test(x)
#       
p1 = mean(x) ; p2 = sqrt(var(x)*(n-1)/n)
#      
pr_obs <- as.vector(table(x)/length(x)) ; nr <- length(pr_obs) 
pr_norm <- dnorm(1:nr, p1, p2) ; pr_pois <- dpois(1:nr, p1)
plot(table(x)/length(x),type="b") #     . 1.3
lines(1:nr, pr_pois , col="red", lwd=2) ; lines(1:nr, pr_norm, col="blue", lwd=2)
#     -
ks.test(pr_obs, pr_norm) ; ks.test(pr_obs, pr_pois)
# --------------------------------------------------------------------------- 
#        Zootoca   
Z <- read.delim("Zootoca.txt") ; x = Z$bm ; summary(x); n <- length(x); mean(x) ; sd(x)
#         
#          CV()   f.CV()
CV <- function(x) sqrt(var(x))/mean(x)  #     
CV(x)     #      
CV(x)+ qt(0.025,df=n-1)*CV(x)/sqrt(n) ; CV(x)+ qt(0.025,df=n-1)*CV(x)/sqrt(n)
#    sample(, replace=T)     ""
#    5000 -    bt
bt <-numeric(5000); for (i in 1:5000) bt[i] <- CV(sample(x, replace=T))
#  -   
hist(bt); mean(bt) - CV(x)  
#      
quantile(bt, prob=c(0.025,0.975))   #  95%  
quantile(bt, prob=c(0.05,0.95))       #   90%  
#       t- -  gt( , df)
mean(bt) - qt(0.975,length(x)-1)*sqrt(var(bt)) 
mean(bt) + qt(0.975,length(x)-1)*sqrt(var(bt))
#      basic CI
2*mean(bt) - quantile(bt,0.025)  ;  2*mean(bt) - quantile(bt,0.975) 
library(boot)  #      boot
#     - boot(),    : 
#  Bootobject <- boot(data= , statistic=, R=, ...),  data -      
#  statistic - ,   k  ; k   1
#  R -   -
#     
f.CV <- function(y,id) {sqrt(var(y[id]))/mean(y[id])}
bootres <- boot(x, f.CV, 5000) #    Bootobject
print(bootres) ; plot(bootres) #     
#       
boot.ci(bootres, conf = 0.95, type = c("norm", "basic", "perc", "bca"))
library(bootstrap)   #      bootstrap
#  95%   
bootres2=boott(x, f.CV, VS=TRUE, v.nboott=5000, perc=c(.025,.975)) ; bootres2[1]
#  95%  ABC- 
thetaCV <- function(p, x)  {xm <- sum(p*x)/sum(p)
den <- sum((p*x - sum(p*x)/sum(p))^2)/(length(x)-1) 
return(sqrt(den)/xm)}
abcnon(x, thetaCV)
#  95%     
jack <- numeric(length(x)-1) ; pseudo <- numeric(length(x))
for (i in 1:length(x))
     { for (j in 1:length(x))
       {if(j < i) jack[j] <- x[j] else if(j > i) jack[j-1] <- x[j]}
     pseudo[i] <- length(x)*CV(x) -(length(x)-1)*CV(jack)}
mean(pseudo) - qt(0.975,length(x)-1)*sqrt(var(pseudo)/length(x))
mean(pseudo) + qt(0.975,length(x)-1)*sqrt(var(pseudo)/length(x))

