#    1.5:
#   )       
#    x       
x <-c(5, 5, 8, 10, 10, 10, 19, 20, 20, 20, 30, 40, 42, 50, 50, 50, 50, 50, 50, 65, 65, 80,
80, 80, 100, 100, 133, 200, 250, 300, 430, 440, 480, 800, 880, 2400, 3020, 3360, 5200, 6200, 7000, 9000, 19000)
#   -    
library(boot) ; f.Med <- function(y,id) {median(y[id])} # ,   
# ------------------------     
#   ,  , 
#  Nmed ,  Nmed -   -,
#      
Genmed <- function (x, Nmed) {
#         
n <-length(x) ; xg <- unique(sort(x)) ; ng <- length(xg) 
#     
p <- cumsum(as.data.frame(table(sort(x)))$Freq/n) 
Meds <- numeric(Nmed) ; for (j in 1:Nmed) { 
#    (0 < tp <1)    ,   
tp <-  runif(1); i <- length(which(p <= tp, arr.ind = FALSE))
#       
if (i == 0) { xtp = xg[1]*tp/p[1] } ; if (i == ng) { xtp = xg[ng] }
if  (i > 0  &  i < ng ) { xtp = xg[i]+(xg[i+1]- xg[i])*(tp - p[i])/(p[i+1]-p[i]) }
Meds[j] <- xtp } ; return (Meds) }
# ------------------------  
Med200 <- Genmed (x, 200) ; quantile(Med200) ; ; plot(density(Med200),col="black", lwd=2)
bootres <- boot(Med200, f.Med, 5000) #    Bootobject
#       
boot.ci(bootres, conf = 0.95, type = c("norm", "basic", "perc", "bca"))
#    )   
#          
lambda_MLE <- function (data) as.numeric(fitdistr(data, "Poisson")$estimate)
#    -   
lambda_boot <- function (data, lambda, B=2000, param = TRUE) {
  result  <- rep(0,B) ; n <- length(data)  
  for(i in 1:B)   {  
   if (param)  y.boot <- rpois(n, lambda)   #    
   else   y.boot <- sample(data, n, replace=TRUE) #    
   result[i] <- lambda_MLE(y.boot)
   } ; return (result) ; }
library(MASS) ; x <-c(rep(0,450),x)  #       450 
lambda_Bootstrap <- lambda_boot (x, lambda_MLE(x))
lambda_Bootstrap <- lambda_boot (x, lambda_MLE(x), param = FALSE)
#       . 1.8
hist(lambda_Bootstrap, xlab = " ", breaks=50, prob=TRUE) 
curve(dnorm(x, mean=mean(lambda_Bootstrap), sd=sd(lambda_Bootstrap)),col='blue',add=TRUE,lwd=2) 
#       
delta <-quantile((lambda_Bootstrap  - lambda_MLE(x)), probs=c(0.025,0.975), names=FALSE) 
L <- lambda_MLE(x)- delta [2] ; abline(v= L, col = "green",lwd=2)
U <- lambda_MLE(x) - delta [1] ; abline(v= U, col = "red",lwd=2)
#    )  
#        Zootoca   
Z <- read.delim("Zootoca.txt") ; x = Z$bm ; summary(x); n <- length(x)
#    (confidence envelope)
library(boot) ; z <- (x - mean(x))/sqrt(var(x))  #   
x.qq <- qqnorm(z, plot.it = FALSE) ; x.qq <- lapply(x.qq, sort)
plot(x.qq, ylim = c(-2, 5), ylab = " Z-", 
xlab = " Z-   ")
#  999 - (..    
#         z)
x.gen <- function(dat, mle) rnorm(length(dat))
x.qqboot <- boot(z, sort, R = 999, sim = "parametric",ran.gen = x.gen)
#     
x.env <- envelope(x.qqboot, level = 0.9)
lines(x.qq$x, x.env$point[1, ], lty = 4, lwd=2)
lines(x.qq$x, x.env$point[2, ], lty = 4, lwd=2)
lines(x.qq$x, x.env$overall[1, ], lty = 1, lwd=2)
lines(x.qq$x, x.env$overall[2, ], lty = 1, lwd=2)
#       
graph_ECFD <- function (x, pc)
#     
{ plot(ecdf(x)) ; lines (x,pc, type="l",col="red", lwd=2) }
graph_EFDD <- function (x, pd)
#      (  )
{ plot(density(x), lwd = 2, col="blue", ylim=c(0,0.082)) ; lines(x, pd,  col="red",lwd = 2)}
library(MASS) ; library(car) ##    
##      
(dof = fitdistr(x,"normal")) ; ep1=dof$estimate[1]; ep2=dof$estimate[2]
ks.test(x,pnorm, mean=ep1,sd=ep2)
##       
(dof = fitdistr(x,"weibull",start=list(scale=1,shape=2))) 
ep1=dof$estimate[1]; ep2=dof$estimate[2]
ks.test(x,pweibull, scale=ep1,shape=ep2)
##    -  
(dof = fitdistr(x,"log-normal")) ; ep1=dof$estimate[1]; ep2=dof$estimate[2]
ks.test(x,plnorm, meanlog=ep1,sdlog=ep2)
graph_ECFD (x, plnorm(x,meanlog=ep1,sdlog=ep2))
graph_EFDD (x, dlnorm(x,meanlog=ep1,sdlog=ep2))
qqPlot(x, dist= "lnorm",meanlog=ep1,sdlog=ep2,xlab="  ", 
     						    ylab=" ", pch=19)
###   )        
#    (   )     
TB <- read.table("ABC_13.txt",header=T,row.names=1,sep="\t"); n=length(TT)
TT <- t(TB[,1]);  TT <- rev(sort(TT[TT>0]))  #     
source("pareto.R") #   ,     
TT.pareto <- pareto.fit(TT,threshold="find") #    
X0 <- TT.pareto$xmin ; teta <-TT.pareto$exponent  ; D <- TT.pareto$samples.over.threshold 
#        
plot.survival.loglog(TT,xlab=", /. ", ylab="   ")
rug(TT,side=1,col="grey") ; curve((D/n)*ppareto(x,threshold=X0,exponent=teta,lower.tail=FALSE), 
add=TRUE,lty=2,from=X0,to=max(TT))
#       teta  
#   B    n      
# exponent  x0     B     teta 
rboot.pareto <- function(B,exponent,x0,n) {  replicate(B,pareto.fit(rpareto(n,x0,exponent),x0)$exponent)}
tboot <- rboot.pareto(1000,teta,X0,n) ; alpha = 0.05  #  
sd(tboot) ;  (mean(tboot) - teta)  #    
# 95%      
(ci.lower <- 2*teta - quantile(tboot,1-alpha/2)) ; (ci.upper <- 2*teta - quantile(tboot,alpha/2))
#     p-  -
#   -    
ks.stat.pareto <- function(data, exponent, x0) {
  ks.test(data[data>=x0], ppareto, exponent=exponent, threshold=x0)$statistic}
#   p-   -
ks.pvalue.pareto <- function(B, data, exponent, x0) {
  testhat <- ks.stat.pareto(data, exponent, x0) ;   testboot <- vector(length=B)
  for (i in 1:B) {    xboot <- rpareto(length(data),exponent=exponent,threshold=x0)
    exp.boot <- pareto.fit(xboot,threshold=x0)$exponent ; testboot[i] <- ks.stat.pareto(xboot,exp.boot,x0) }
  p <- (sum(testboot >= testhat)+1)/(B+1)  return(p) }
# ------------------------  
ks.stat.pareto(TT,teta,X0)
ks.pvalue.pareto(1000,TT,teta,X0)
