#   2.7:
#      
#        
r1 <- c(40,1500,9750,18510,6640,1200,2140,8960,8620,6860,2100,4660,2420,8560,560,1920,11860,2260,3840,3220)
r2 <- c(660,1440,620,860,4180,1780,1260,100,740,3400,4760,2860,3300,3180,1180,920,340,740,7940)
r3 <- c(1720,11920,2880,18000,217000,37080,10880,1280,160)
r4 <- c(5640,5120,160,40,2600,3840,27954,14640)
Data <- data.frame(    Y=c(r1, r2, r3, r4),River = factor(rep(c("", "", "", ""), 
times=c(length(r1), length(r2), length(r3), length(r4)))))
#       
m.full <- lm(Y~River, data=Data) ; anova.res = anova(m.full) ; nperm=5000 ; n = nrow(Data)
#       ANOVA     Y
   k = nrow(anova.res) - 1 ;  GE = rep(1,k) ; Pperm = c(rep(0,k), NA)
   for(j in 1:nperm)    {
      Yperm = sample(Data$Y,n) ; toto = lm(Yperm ~ River, data=Data) ;  anova.per = anova(toto)
      for(i in 1:k) { if(anova.per[i,4] >= anova.res[i,4]) GE[i] = GE[i] + 1 } }
   for(i in 1:k) { Pperm[i]=GE[i]/(nperm+1) } ;    anova.res  = data.frame(anova.res, Pperm)
   colnames(anova.res) = c("..", " .SS", ". . MS", "F ", "P()", "P()")
(anova.res) 
#  null-        
m.null <- lm(Y~1,data=Data) ; print(anova(m.null, m.full))
#      " " 
TukeyHSD(aov(Y~River, data=Data)) 
#  -    
shapiro.test(m.full$residuals)
#  -
library(car)
#          -   
bc.full <- boxCox(m.full,ylab = "log  " ); bc.full.opt <- bc.full$x[which.max(bc.full$y)]
print(paste("  -   :",bc.full.opt))
#        
Data$Y.bc.full <- bcPower(Data$Y, bc.full.opt) ; m.bc.full <- lm(Y.bc.full ~ River, data=Data)
#     -     
TukeyHSD(aov(Y.bc.full~River, data=Data)) ; shapiro.test(m.bc.full$residuals)
#   -   
bc.null <- boxCox(m.null); bc.null.opt <- bc.null$x[which.max(bc.null$y)]
print(paste("  -   :",bc.null.opt))
Data$Y.bc.null <- bcPower(Data$Y, bc.null.opt) ; m.bc.null <- lm(Y.bc.null ~ 1, data=Data)
#      
print(anova(m.bc.null, m.bc.full))
