#    2.9:
#         
#          xls
library(xlsReadWrite)
#  1-   -    ,  2-   -  
TTB <- t(read.xls("_.xls", sheet = 1, rowNames=TRUE))
TTB.taxon <- read.xls("_.xls", sheet = 2, rowNames=TRUE)
#    3-   -     
TR  <-  read.xls("_.xls", sheet = 3, rowNames=TRUE) 
#      .    
s1 <- apply(TTB[1:5,],2,sum) ; s2 <- apply(TTB[6:9,],2,sum) ; TT2S <- t(data.frame(s1, s2))
library(vegan) 		#   vegan
#    -    
# data -  , Nperm -  , fixedmar, shuffle -  permatfull
# divdiff -      
p.rand <- function(data, fixedmar, shuffle, Nperm=999) {
d_emp <- divdiff(data)  ; d_rand <- as.numeric(rep(NA,Nperm)) 
for (i in 1:Nperm) { 
x3 <- permatfull(data, fixedmar = fixedmar,shuffle = shuffle, times = 1)
TT_rand <- as.matrix(x3$perm[[1]]) ; d_rand[i] <- divdiff(TT_rand) }  
RandRes (d_emp, d_rand , Nperm) }
source("print_rezult.r")  #    

#    -------------    )  
#       
taxdisB <- taxa2dist(TTB.taxon, varstep=TRUE)
#      9  .  (   )
 mod <- taxondive(TTB, taxdisB); write.table(summary(mod), file="clipboard", sep="\t")
plot(mod)  #    
#     
TaxEnt <- function (spec, taxdis) {
k_sum <- apply(as.matrix(taxdis),1,sum); k_sum <- k_sum/sum(k_sum)
SH <- as.numeric(rep(NA, nrow(spec)))
for (i in 1:nrow(spec)) SH[i] <- sum(spec[i,]*log(k_sum))/sum(spec[i,]) ; return (SH) }
TaxEnt(TTB, taxdisB)
#     2 
 mod2 <- taxondive(TT2S, taxdisB);  summary(mod2) ; TaxEnt(TT2S, taxdisB)
#            
#     +    
divdiff <- function(x) { m <- taxondive(x, taxdisB); m$Dplus[2]-m$Dplus[1]}
#         
#   divdiff <- function(x) { m <- taxondive(x, taxdisB); m$D[2]-m$D[1]}
p.rand (TT2S,fixedmar = "none", shuffle = "samp")     # 1.   EE
p.rand (TT2S,fixedmar = "columns", shuffle = "samp")  # 2.    ( EF1)
p.rand (TT2S,fixedmar = "columns", shuffle = "both")  # 3.     EF2
p.rand (TT2S,fixedmar = "both", shuffle = "both")     # 4.    FF

#    -------------    )  
#        
hist(TR$IM) ; TR$IMlog <- log2(TR$IM) ; hist(TR$IMlog) 
#     
bentosTraits <- subset(TR, select = "IMlog")  ;  bentosAbun   <-  decostand( TTB, "log")
library(FD)    #         
result <- dbFD(bentosTraits, bentosAbun) 
 write.xls(as.data.frame(result), "fdr.xls") #       Excel
#     2 
bentosAbun2s   <-  decostand(TT2S , "log") ; result2s <- dbFD(bentosTraits, bentosAbun2s)
#   permatfull        
CW <- functcomp(bentosTraits, TT2S)  #       CWM
divdiff <- function(x) { colnames(x) <- rownames(bentosTraits)
CW.val <- functcomp(bentosTraits, x); CW.val[2,] - CW.val[1,]}
p.rand (TT2S,fixedmar = "none", shuffle = "samp")     # 1.   EE
p.rand (TT2S,fixedmar = "columns", shuffle = "samp")  # 2.    ( EF1)
p.rand (TT2S,fixedmar = "columns", shuffle = "both")  # 3.     EF2
p.rand (TT2S,fixedmar = "both", shuffle = "both")     # 4.    FF
