#    3.1:
#      
#     :  NDO -   Diamesinae+Orthocladiinae
#    T  -       
NDO <- c(88.9,94.9,70.8,46.4,31.0,66.5,83.6,71.9,59.6,22.5,29.2,6.5,17.5)
T <- c(14.8,14.5,11.5,12.6,12,14.5,13.3,16.7,16.9,20.6,21.2,22.5,22.4)
#   -     
(cors <- cor.test(NDO,T,method = "pearson"))  
library(psych) #   Z-    
zs <- fisherz(cors$estimate); rs <- fisherz2r(cors$estimate) ; round(zs,2)
r.con(cors$estimate,length(T))
cor.test(NDO,T,method = "kendall");cor.test(NDO,T,method = "spearman")
source("print_rezult.r")  #    
#        
PermCor <- function (X, Y, method="pearson" , Nperm=5000) {
PermArray <- as.numeric(rep(NA, Nperm)) ;  for (i in 1:Nperm) #     Y
  PermArray[i] <- as.numeric(cor.test(X,sample(Y,length(Y)),method = method)$estimate)
return (RandRes(cor.test(X,Y,,method = method)$estimate, PermArray, Nperm)) }
#         
BootCor <- function (X, Y, method="pearson" , Nboot=5000) {
Remp <- as.numeric(cor.test(X,Y,method = method)$estimate) ; n <- length(Y)
BootArray <- as.numeric(rep(NA, Nboot)) ; for (i in 1:Nboot) {
Ind <- sample.int(n, size = n, replace = TRUE)  #      
BootArray[i] <- as.numeric(cor.test(X[Ind],Y[Ind],method = method)$estimate) }
return (BootRes(BootArray, Remp)) }
#    
PermCor(NDO,T) ; BootCor(NDO,T)  
PermCor(NDO,T, method = "kendall") ; BootCor(NDO,T, method = "kendall") 
PermCor(NDO,T, method = "spearman") ; BootCor(NDO,T, method = "spearman")
