#    3.4:
#      
#         
x <- c(19.1, 22.4, 21.7, 20.2, 25.1, 18.6, 15.6, 17.6, 13.5, 22.4, 14.2, 13.3, 17.9, 24.6, 25.8, 16.1, 16.6, 31.2, 15.8, 11.4, 20.3, 6.2, 8.9, 9.4, 6.4, 9.21, 2.6, 8.2)
y <- c(24.5, 19.6, 22.2, 24.3, 25.5, 25.5, 25.2, 23.9, 26.1, 25.3, 21.9, 20.6, 27.1, 43.2, 25.6, 24.9, 25.8, 23.8, 23.5, 21.1, 23.8, 0.8, 15.5, 2.6, 2.8, 0.9, 5.7, 1.4)
xy <- data.frame(x,y)
library(compositions)
library(boot)

# 1. ,   
lmodel <- "y ~ x"   #  
#        lm()  glm()
fit <- lm(lmodel); summary(fit)
#   -    R2  AIC
#        
N = 1000; k1 = summary(fit)$r.square ; k2 = AIC(fit)
cnt1=0 ; cnt2=0  #     1- 
for(i in 1:N){ xp=sample(x) #   x
if (summary(lm(formula = y ~ xp))$r.square <= k1)  cnt2=cnt2 + 1
if (AIC(lm(formula = y ~ xp)) >= k2)  cnt2=cnt2 + 1}
cnt1*100/N ; cnt2*100/N
#    -      AIC
vyb <- t(replicate(1000, sample.int(length(x), replace=TRUE)))
bAIC <- sapply(1:1000, function (i) {l<-vyb[i,]; AIC(lm(y[l] ~ x[l])))})
hist(bAIC); mean(bAIC) - k2 ; quantile(bAIC, prob=c(0.025,0.975)) 
fit <- glm(lmodel, gaussian); summary(fit)
#  -     : 1 28  4 7
cv.glm(xy, fit) ;  cv.glm(xy, fit, K = 7)$delta
#       :
lmodel <- "y ~ I(1/x)"   #  
lmodel <- " y ~ x + I(x*x)"   #   2   
lmodel <- " y ~ x + I(x*x)+ I(x*x*x)"   #   3   

#        (. 3.8)
m = 100 ; p2.fit <- lm( y ~ x + I(x*x)) ; xy <- data.frame(x,y); n <- nrow(xy)
sr <- qt(0.975, n-2)*summary(p2.fit)$sigma #     
x.grid <- seq(from=min(x),to=max(x),length.out=m) 
eval.grid <- data.frame(x=x.grid) #   m  
p2.CI <- predict(p2.fit,newdata = eval.grid, level=0.95, interval="conf")  # Confidence Interval
p2.PI <- predict(p2.fit,newdata = eval.grid, level=0.95, interval="pred")  # Prediction Intervals
#  -     (3  )
xy.resampler <- function() {   #  ,      
resample.rows <- sample(1:n,size=n,replace=TRUE); return(xy[resample.rows,]) }
xy.p2.estimator <- function(data,m=100) {  #  ,  ,   
fit <- lm(y ~ x + I(x*x),data) ; return(predict(fit,newdata=eval.grid)) }
xy.p2.cis <- function(B,alpha,m=100) { #  ,   
xy.main <- xy.p2.estimator(xy,m)
xy.boots <- replicate(B,xy.p2.estimator(xy.resampler(),m))
cis.lower <- 2*xy.main - apply(xy.boots,1,quantile,probs=1-alpha/2)
cis.upper <- 2*xy.main - apply(xy.boots,1,quantile,probs=alpha/2)
return(list(main.curve=xy.main,lower.ci=cis.lower,upper.ci=cis.upper)) }
xy.ci <- xy.p2.cis(B=1000,alpha=0.05)  #   
#        
plot(x, y, pch=16, main="") ; lines(x=x.grid, y=p2.CI[,1],lwd=2) 
lines(x=x.grid, y=p2.CI[,2],col="red", lty=2); lines(x=x.grid, y=p2.CI[,3],col="red", lty=2) 
lines(x=x.grid,y=xy.ci$lower.ci,col="red") ; lines(x=x.grid,y=xy.ci$upper.ci,col="red")
lines(x=x.grid, y=p2.PI[,2],col="blue", lty=2); lines(x=x.grid, y=p2.PI[,3],col="blue", lty=2) 
lines(x=x.grid, y=p2.CI[,1]+sr,col="green",lty=2); lines(x=x.grid, y=p2.CI[,1]-sr,col="green",lty=2)

# 2.   ( )
fit <- nls(y ~exp(a*x)*x^b, start = list(a=0.3, b=1.1)); summary(fit)
#     R2 
N = 1000; k1 = R2(fit)
vyr <- t(replicate(N, sample(length(x), replace=FALSE)))
bR2 <- sapply(1:N, 
function (i) {l<-vyr[i,]; R2(nls(y[l] ~exp(a*x)*x^b, start = list(a=0.3, b=1.1)))})
sum(bR2< k1)*100/N
#      
vyb <- t(replicate(1000, sample.int(length(x), replace=TRUE)))
bka <- sapply(1:1000, function (i) {l<-vyb[i,]; 
	fp <- coef (nls(y[l] ~exp(a*x[l])*x[l]^b, start = list(a=0.3, b=1.1))); fp[1]})
hist(bka);  quantile(bka, prob=c(0.025,0.975))   #   a
bkb <- sapply(1:1000, function (i) {l<-vyb[i,]; 
	fp <- coef (nls(y[l] ~exp(a*x[l])*x[l]^b, start = list(a=0.3, b=1.1))); fp[2]})
hist(bkb);  quantile(bkb, prob=c(0.025,0.975)) #   b
#  -    : 1 28
n <- length(x) ; rss=0
for(i in 1:n){xp = x[-i] ; yp = y[-i]
c = coef(nls(yp ~exp(a*xp)*xp^b, start = list(a=0.3, b=1.1)))
e = y[i] - (exp(c[1]*x[i])*x[i]^c[2])
rss=rss + e*e} ; rss/n
#       :
fit <- nls(y ~ a*exp(b*x), start = list(a=5, b=0.1)); summary(fit)
fit <- nls(y ~ a*x^b, start = list(a=0.3, b=1.1)); summary(fit)
fit <- nls(y ~a + b*x + c*log(x), start = list(a=0.3, b=1.1, c=1.1)); summary(fit)
fit <- nls(y ~a/(1+exp(b+c*x)), start = list(a=43, b=3, c=-0.15)); summary(fit)
