#    3.6:
#       
#  .         :
install.packages("gravy", repos="http://sci.muni.cz/botany/zeleny/R/windows/contrib/R-2.12")
  JUICE.short.head <- read.table("ShortHead.txt", sep="\t", head = T)
  JUICE.species.data <- read.table ("SpeciesData.txt", sep="\t",head = T)
  JUICE.table <- read.table ("Table.txt", sep = "\t", check.names = F, head = T, row.names = 1)
#         
source("species_response_curves.r")
#         result_table.csv
#       ,      
#         ,  . 
#   ,    count.GLM   61  species_response_curves.r 
#      save(glm.1,glm.2,part.species, gr, file = "xy.RData")
#         :
load("xy.RData")
#      GLM  1-   
summary(glm.1) ; summary(glm.2)
Nrand = 1000  #     
#   1000      
vyb <- t(replicate(Nrand, sample(gr, replace=FALSE)))
#     1    1-    
#     
Ra11 <- sapply(1:Nrand, function (i) {
	coef (glm(formula = part.species ~ poly(vyb[i,], 1), family = "binomial"))[2]})
#   -   1  1- 
p_a11 <- (sum(abs(Ra11)- abs(coef(glm.1)[2]) >= 0)+1) / (Nrand + 1)
#       2  2- 
Ra22 <- sapply(1:Nrand, function (i) {
	coef (glm(formula = part.species ~ poly(vyb[i,], 2), family = "binomial"))[3]})
p_a22 <- (sum(abs(Ra22)- abs(coef(glm.2)[3]) >= 0)+1) / (Nrand + 1)
