#    4.5:
#      
#       
load("Fito.RData")  ;  library(glmulti) ; library(boot) ; library(MASS) ; library(car)
corsig <- function(x){  #      -
x <- as.matrix(x) ; R <- rcorr(x)$r ; p <- rcorr(x)$P
ipa <- lower.tri(p, diag = FALSE) ; R[ipa] <- p[ipa] ; return (R) }
write.table(round(corsig(Fito),4),"clipboard",sep="\t")  #    
#      1- 
RegModel.2 <- lm(Bmass~Ca+Carb+Cl+H+Mg+Na+Sulfat, data=Fito) ; summary(RegModel.2)
vif(lm(Bmass~Ca+Carb+Cl+H+Mg+Na, data=Fito))  #    VIF-
stepAIC(RegModel.2,data=Fito)  #      
library(lars)  #     
m.lasso <- lars(as.matrix(Fito[,2:8]),Fito[,1]) ; plot(m.lasso)
r <- cv.lars(as.matrix(Fito[,2:8]),Fito[,1]) ; bestfrac <- r$index[which.min(r$cv)]     # -
coef.lasso <- predict(m.lasso,as.matrix(Fito[,2:8]),s=bestfrac,type="coefficient",mode="fraction")
coef.lasso  #   
y.pred.lasso <- predict(m.lasso,as.matrix(Fito[,2:8]),s=bestfrac,type="fit",mode="fraction")$fit
summary(sqrt((y.pred.lasso - Fito[,1])^2))  #      
#   1-    
prednames <- names(Fito)[2:8] ; glmulti("Bmass",xr=prednames,data=Fito,family = gaussian,level=1)
sqrt(cv.glm(Fito,  glm(Bmass~Carb+H+Mg, data=Fito))$delta) #   -
summary(m2 <- glm(Bmass~H+Mg, data=Fito)) ; sqrt(cv.glm(Fito, m2)$delta)
# -       
# ,   
bootF <- function(data, indices){data <- data[indices,] 
mod <- lm(Bmass ~ Bmass ~ 1 + Carb +H + Mg, data=data) coefficients(mod) }
Fito.boot <- boot(Fito, bootF, 1000) ; Fito.boot
boot.ci(Fito.boot,  index = 2 , type= type = c("norm", "basic", "perc", "bca")) # Carb
data.ellipse(Fito.boot$t[,2], Fito.boot$t[,3], xlab="Na", ylab="H", 
cex=.3, levels=c(.9, .95, .99), robust=T)
#  -  
rsq <- function(data, indices){data <- data[indices,] 
mod <- lm(Bmass ~ 1 + Carb +H + Mg, data=data) ; return(summary(mod)$r.square)}
Rsq.boot <- boot(Fito, rsq, 1000)  ; boot.ci(Rsq.boot,   type="bca") # R2
