#    4.6:
# 4.7.	     
library(xlsReadWrite) ; library (gam); library(car); library(MuMIn) 
TOR <- read.xls("Ruts.xls", sheet = 1, rowNames=TRUE) ; attach (TOR)
#        
x<-W[order(W)] ; y <-C[order(W)] ; spanlist <- c(0.15, 0.50, 1.00, 2.00)
# 15      
MissingList <- sample(x,15); x[MissingList] <- NA
#     
plot(x,y, xlab=" , ", ylab=" , ")
#    LOESS     span  
for (i in 1:length(spanlist)) {
  y.loess <- loess(y ~ x, span=spanlist[i], data.frame(x=x, y=y))
  y.predict <- predict(y.loess, data.frame(x=x)) ;  lines(x,y.predict,col=i)
  #       
  y.Missing <-  predict(y.loess, data.frame(x=MissingList))
  points(MissingList, y.Missing, pch=FILLED.CIRCLE<-19, col=i) }
legend ("bottomright", c(paste("span =", formatC(spanlist, digits=2, format="f"))),
        lty=SOLID<-1, col=1:length(spanlist), bty="n")
#         spar  
x<-Lt[order(Lt)] ; y <-H[order(Lt)] 
plot(x,y,xlab=" , ", ylab=" , ") ; abline(lm(y ~ x),col="grey")
sp.spline <- smooth.spline(x,y,cv=TRUE) ; lines(sp.spline, lwd=2) #  
lines(smooth.spline(x,y,spar=1.5),col="blue"); lines(smooth.spline(x,y,spar=1),col="blue",lty=2)
lines(smooth.spline(x,y,spar=0.5),col="red") ; lines(smooth.spline(x,y,spar=0.3),col="red",lty=2)
legend ("bottomright", c("spar = 0.3",  "spar = 0.5", "spar = C.V", "spar = 1","spar = 1.5"),
col = c("red", "red", 1, "blue", "blue"), lty = c(2,1,1,2,1))
#        
Labels <- c(""," ", " ", "") 
scatterplotMatrix(~SR + R +  W + age1,var.labels = Labels, data = TOR, diag = "boxplot")
#   GAM
dredge(gam(C ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR), rank = "AIC")
dredge(gam(R ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR), rank = "AIC")
dredge(gam(SR ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR), rank = "AIC")
dredge(gam(H ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR), rank = "AIC")
dredge(gam(L ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR), rank = "AIC")
#      GAM      
C.gam <- gam(C ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR)
R_1.gam <- gam(R ~ lo(W) + lo(Lt) , family = gaussian, data = TOR)
SR_1.gam <- gam(SR ~ lo(age1)+ lo(Lt)+ lo(mon) , family = gaussian, data = TOR)
H_1.gam <- gam(H ~ lo(W) + lo(Lt) , family = gaussian, data = TOR)
L_1.gam <- gam(L ~ lo(W) + lo(Lt) , family = gaussian, data = TOR)
TOR.fit <- data.frame(TOR, C.res = C.gam$res , C.fit = C.gam$fit, 	R.res=R_1.gam$res,R.fit=R_1.gam$fit,SR.res=SR_1.gam$res,SR.fit=SR_1.gam$fit,
	H.res=H_1.gam$res,H.fit=H_1.gam$fit,L.res=L_1.gam$res,L.fit=L_1.gam$fit)
save(TOR.fit, file="Ruts.RData")  #        
H.gam <- gam(H ~ lo(W) + lo(Lt) + lo(age1) + lo(mon), family = gaussian, data = TOR)
summary(H.gam) ; anova(H.gam, H_1.gam)  #      
plot(H_1.gam,residuals=TRUE,se=TRUE, ask =TRUE)  #     
summary(lm(H ~ W + Lt , family = gaussian, data = TOR)) #     
#            
attach(TOR.fit) ; summary(aov(R ~ M + sex))
summary(aov(R.fit ~ M + sex)) ; summary(aov(R.res ~ M + sex))
