#    5.2:
#  5.2.	    
#        (.  4.4.)
load(file="Sok.RData") 
# attach  ""   
attach(TTB.Site) ; library(vegan)
River = as.factor(River)   #  
num_Site = as.factor(num_Site)    #  
#   npMANOVA    
adonis(formula = TTB ~ River + num_Site %in% River, data = TTB.Site, 
strata= River, method="jac", binary=TRUE,  permutations = 999)
D <- vegdist(TTB)  #      -ʸ
#      Adonis()    :
adonis(formula = D ~ River + Site %in% River, data = TTB.Site, strata= River,    permutations = 999)
#     -  betadisper
mod <- betadisper(D, River, type = "centroid")
#     ,     1-2  1-3  
anova(mod) ; plot(mod);   plot(mod, axes = c(3,1)
#    ,   "  "  
permutest(mod, pairwise = TRUE) ; boxplot(mod)
#      HSD,     
(mod.HSD <- TukeyHSD(mod)) ;  plot(mod.HSD)
#     - ""  
#             
TTB.agrs <- aggregate(TTB,list(TTB.Site$Site), FUN = mean) ; TTB.agrs <- TTB.agrs[,-1]
rownames(TTB.agrs)<- c("_01","_03","_06","_07","_01","_02","_03","_05",
"_08","_10","_12","_14")
#      -ʸ  12 
library(gclus) ; Da <- vegdist(TTB.agrs)  
#        coldiss()  (Borcard et al., 2011)   
source("coldiss.r") ; coldiss(Da,byrank=TRUE, diag=TRUE)
