#    5.3:
#         
#        
load(file="Fito_Full.RData") ;  library(vegan)
#          
Species <- Fito_Full[,3:25] ;  Species[Species<0] <- 0
SpecN <- decostand(Species, method="hellinger") ; D_spec <- dist(SpecN)
#    ,     
Envir <- Fito_Full[,27:36] ; EnvN <- decostand(Envir, method="standardize")
#       
D_env <- dist(EnvN)
#      ,    
library(gmt) ; Geo <- Fito_Full[,37:38]
Geo$Yc <- deg2num(gsub(" ","", Geo$Yc , fixed=TRUE))
Geo$Xc <- deg2num(gsub(" ","", Geo$Xc , fixed=TRUE))
# geodist(Geo$Yc[1], Geo$Xc[1], Geo$Yc[2], Geo$Xc[2])  = 2.943368
#      ()     
library(geosphere) ; D_geo <- as.dist(distm(Geo)/1000)
#        
save(Species,D_spec,Envir,D_env, Geo, D_geo,file="Fito_Dmat.RData")
#     -   
#   ,       ,
#      20    159
row.names(Geo) <- Fito_Full[,2] ; Geo2 <- Geo[sample(159,20),]
plot(Geo$Xc, Geo$Yc,asp=1,  pch=21, col="white", bg="yellow", cex=5*(Fito_Full[,26])/max((Fito_Full[,26])))
text(Geo2$Xc, Geo2$Yc, row.names(Geo2), cex=0.5, col="black")
#    
mantel(D_spec, D_env)  #   " "  ~ " "
mantel(D_spec, D_geo)   #   " "  ~ " "
mantel(D_env, D_geo)    #   " "  ~ " "
mantel.partial(D_spec, D_env, D_geo)  #       
