#    6.4:      
library(xlsReadWrite) ; library(rpart) ; library(rpart.plot)
TOR <- read.xls("Ruts.xls", sheet = 1, rowNames=TRUE) ; attach (TOR)
#      rpart
rut.rpart <- rpart(formula = M ~ sex+W+Lt+C+R+SR+H+L, method="class", data=TOR)
prp(rut.rpart, extra=1,box.col=c("pink", "yellow", "palegreen3")[rut.rpart$frame$yval])
rut1.rpart <- rpart(M~sex+W+Lt+C+R+SR+H+L, method="class", data=TOR,
control=rpart.control(cp=.005))  #        
#         
plotcp(rut1.rpart) ; with(rut1.rpart, {lines(cptable[,2]+1,cptable[,3],type="b",col="red")
legend(locator(1),c(" "," - (CV)","min(CV )+SE"),
lty=c(1,1,2),col=c("red","black","black"),bty="n") }) ; printcp(rut1.rpart)
table(predict(rut.rpart, type = "class"),TOR$M) #   
library(randomForest)    #      
rut.rf <- randomForest(as.factor(M) ~ sex+W+Lt+C+R+SR+H+L, data=TOR, importance=TRUE
library(party)  #      " "
rut.ctree <- ctree(sex ~ W+Lt+C+R+SR+H+L, data=TOR); plot(rut.rpart) ; text(rut.rpart) 
