#   6.9
#    
#        
random.imp <- function (a){
missing <- is.na(a) ; n.missing <- sum(missing) ; a.obs <- a[!missing] ; imputed <- a
imputed[missing] <- sample (a.obs, n.missing, replace=TRUE)
return (imputed) }
#     
library(xlsReadWrite) ; PT <- read.xls(".xls", sheet = 2, rowNames=FALSE) 
Stan.f <- as.factor(PT[,2]) ; X <- as.data.frame(PT[,4:9])
Stan.list <-unique(Stan.f) ; XP <- X ; Pl.f <- as.factor(PT[,1])
for (i in 1:length(Stan.list)) {
Ind <- which(Stan.f==Stan.list[i]); XP[Ind,] <- apply(X[Ind,], 2, random.imp) }
by(XP, Pl.f, function(x)    apply(x, 2, mean))    #      
#   SOM     
library(kohonen)
PT.som <- som(data = as.matrix(XP), grid = somgrid(5, 6, "hexagonal"))
plot(PT.som, type = "codes") ; plot(PT.som, type = "counts")
plot(PT.som, type = "dist.neighbours") 
plot(PT.som, type = "mapping", col =as.integer(Pl.f), pch = 16, bgcol = gray(0.85))
