#      7.3:
#      :   
load(file="time_ser.RData")
#       
index <- 1:length(OUT$) ; time=(index)/12
mod.trend <-lm(OUT$~index + sin(time*2*pi)+cos(time*2*pi))
summary(mod.trend) ; AIC(mod.trend)
model<-lm(OUT$~sin(time*2*pi)+cos(time*2*pi))
summary(model); AIC(model) ; anova(mod.trend,model)
plot(time, OUT$, type="l") ; lines(time, predict(model), col="red", lwd=2)
#   :   -      
rblockboot <- function(ts,block.length,len.out=length(ts)) {
  blocks.needed <- (len.out%/%block.length) ; n <- block.length*blocks.needed ;   x <- ts[1:block.length]
  for (l in 2:blocks.needed) { x <- cbind(x, ts[((l-1)*block.length+1):(l*block.length)]) }
  picked.blocks <- sample(1:blocks.needed,replace=TRUE) ;   x.boot <- x[,picked.blocks]
   x.vec <- as.vector(x.boot) ;   return(x.vec)  }
library(car) ; N_Boot = 1000  ; A.boot <- B.boot <- rep(0,N_Boot)
for (i in 1:N_Boot) { boot <- rblockboot(OUT$,12)
model.boot<-lm(boot~sin(time*2*pi)+cos(time*2*pi))
A.boot[i] <- model.boot$coefficients[2]; B.boot[i] <- model.boot$coefficients[3]}
data.ellipse(A.boot, B.boot, xlab="sin(w)", ylab="cos(w)", cex=.3, levels=c(.5, .95, .99), robust=T)
#     
library(forecast); WIND.tr <- window(WIND.repl,start=c(1961,1), end=c(1986,6)) 
WIND.ex <- window(WIND.repl,start=c(1986,7), end=c(1988,12))
WIND.m1  <- meanf(WIND.tr, h=30) ;                     plot(WIND.m1, plot.conf=TRUE) 
WIND.m2 <- rwf(WIND.tr, h=30, drift=TRUE) ;    lines(WIND.m2$mean,col=2)
WIND.m3 <- snaive(WIND.tr, h=30) ;                     lines(WIND.m3$mean,col=3)
legend("topleft",lty=1,col=c(1,2,3),   legend=c(""," ",""))
accuracy(WIND.m1, WIND.ex)   #    
accuracy(WIND.m2, WIND.ex) ; accuracy(WIND.m3, WIND.ex)
#   - :           a)    
WIND.HW <- HoltWinters(WIND.tr,  beta=FALSE, gamma=FALSE)
WIND.forecast <- forecast.HoltWinters(WIND.HW, h=30) ; plot(WIND.forecast)
accuracy(WIND.forecast, WIND.ex)
WIND.HW <- HoltWinters(WIND.tr)  #   )  
WIND.forecast <- forecast.HoltWinters(WIND.HW, h=30) ; plot(WIND.forecast)
lines(WIND.HW$fitted[,1], col=3, lwd=2)
accuracy(WIND.forecast, WIND.ex)
WIND.HW <- HoltWinters(WIND.tr,  seasonal = "multiplicative") #   ) 
WIND.forecast <- forecast.HoltWinters(WIND.HW, h=30) ; plot(WIND.forecast)
accuracy(WIND.forecast, WIND.ex)
ets(y = WIND.tr, damped = FALSE)  #     
WIND.HW <- HoltWinters(WIND.tr,  beta=FALSE)  #   )   
WIND.forecast <- forecast.HoltWinters(WIND.HW, h=30) ; plot(WIND.forecast)
accuracy(WIND.forecast, WIND.ex)
#   ARIMA
WIND.arima <- auto.arima(WIND.tr) ; WIND.forecast <- forecast(WIND.arima, h=30)
plot(WIND.forecast) ; summary(WIND.forecast); accuracy(WIND.forecast, WIND.ex)


