#      7.7:
#        -
#   1  -        
r=scan("blindern_tersklet.txt") ; k1=k2=n1=n2=k=0 ; n=length(r) ; k=sum(r)
for(i in 2:n) {
  if(r[i-1]==1)   {  #  596     202       
    n1=n1+1 ;   k1=k1+r[i]   }
  if(r[i-1]==0)    {   #  3055     393       
    n2=n2+1 ;   k2=k2+r[i]   }
}
#     [0, 1]  400     
p = p.m = p1 = p2 = seq(0.0025,1-0.0025,0.0025)
prior.p=prior.p1=prior.p2=rep(1/length(p),length(p)) #    
#        
lik.p=log(p)*k+log(1-p)*(n-k) 
lik.p1=log(p1)*k1+log(1-p1)*(n1-k1) ;  lik.p2=log(p2)*k2+log(1-p2)*(n2-k2)
#     max.p    
max.p=max(lik.p) ; lik.p=lik.p-max.p ; lik.p=exp(lik.p)
post.p=lik.p*prior.p ; post.p=post.p/sum(post.p)   #    
lik1=sum(lik.p*prior.p)  #       1
#      2
max.p1=max(lik.p1) ; lik.p1=lik.p1-max.p1 ; lik.p1=exp(lik.p1) ; post.p1=lik.p1*prior.p1 
 post.p1=post.p1/sum(post.p1)
max.p2=max(lik.p2) ; lik.p2=lik.p2-max.p2 ; lik.p2=exp(lik.p2) ; post.p2=lik.p2*prior.p2
post.p2=post.p2/sum(post.p2)
lik2=0 ; for(i in 1:length(p1))
  for(j in 1:length(p2))
    lik2=lik2+(p2[j]/(1-p1[i]+p2[j]))^r[1]*(1-p2[j]/(1-p1[i]+p2[j]))^(1-r[1])
*lik.p1[i]*lik.p2[j]*prior.p1[i]*prior.p2[j]
B=lik1/lik2*exp(max.p-max.p1-max.p2)   #    
par(mfrow=c(2,1))  #      
plot(p1, post.p1, xlim=c(0,0.42), type="h", xlab="p1", ylab="Pr(p1|D)", lwd=3)
plot(p2, post.p2, xlim=c(0,0.42), type="h", xlab="p2", ylab="Pr(p2|D)", lwd=3)
#    (p1 - p2) 
diff.p=seq(-1+0.0025,1-0.0025,0.0025) ; post.diff.p=rep(0,length(diff.p))
for(i in 1:length(p1)) 
  for(j in 1:length(p2))
    {      index=i-j+length(p1)
      post.diff.p[index]=post.diff.p[index]+post.p1[i]*post.p2[j]     }
plot(diff.p,post.diff.p, xlim=c(0.1,0.3), type="h", xlab="p1-p2", ylab="Pr(p1-p2|D)", lwd=3)
sum(diff.p*post.diff.p)  ; sum(post.diff.p[diff.p<0])

#   2 -      
Z <- read.delim("Zootoca.txt")
#      Huxley
y <- log(Z$svl) ; x <- log(Z$bm); lmod <- lm(y~x) ; summary(lmod)
plot(x,y, xlab='  ln(), ',ylab='  ln(), ')
matplot(x,predict(lmod, interval="confidence"),type='l',lty=c(1,2,2), col=4, add=T)
#    
set.seed(3) ; n.obs <- length(x) ;  chain.len <- 100000  #     
#         
write("model {
for (i in 1:n) { y[i] ~ dnorm(beta1+beta2*x[i],1/sigma2)}
  beta1 ~ dnorm(0,0.000001)
  beta2 ~ dnorm(0,0.000001)
  sigma2 ~ dunif(0,10^6) }
  }", "simple_regression.jags ")
library(rjags)  #     JAGS-3.0        
model <- jags.model("simple_regression.jags", data=list('y'=y,'x'=x,'n'=n.obs),n.chains=2,n.adapt=1000)
#    
result <- coda.samples(model, variable.names=c("beta1","beta2","sigma2"),n.iter= chain.len)
#       
library(ggmcmc) ; df <- ggs(result) ; summary(subset(df,Parameter=="beta2" & Chain==2, select=value))
ggs_density(df) ; ggmcmc(df, file = " Zootoca model.pdf", param.page = 1)

#   3  -       . 
load("BSuzA.RData"); str(BSuzA) ; summary(aov(Level~Stan,BSuzA)) #      
#          
library(lme4) ; mod_s<-lmer(Level~Stan+(1|Year)+ (1|Month),BSuzA ) ;anova(mod_s) 
#        HPD 
cfi<-mcmcsamp(mod_s,n=10000,saveb=T) ; HPDinterval(cfi) ; densityplot(cfi) # 10000 
