#         G
RandRes <- function (emp, sim, Nrand = 999, w.plot = 0) { 
# : emp -    Gobs; 
# 		sim -     Gran
# Nrand -   ;   w.plot <> 0  -    
#         
CI <-  as.matrix(rep(NA, 7)) ; ; colnames(CI) <- ""
rownames(CI) <- c("..",".","CI", "CI", "(>)","(<)","(||>||)")
  CI[1] <-  emp ;   CI[2] <- mean(sim)
#       
  CI[3] <- quantile(sim, prob=0.025) ;   CI[4] <- quantile(sim, prob=0.975)
#     
CI[5] <- (sum(sim >= emp)+1) / (Nrand + 1) ; CI[6]  <- (sum(sim <= emp)+1) / (Nrand + 1) 
#     
CI[7]   <- (sum(abs(sim)- abs(emp) >= 0)+1) / (Nrand + 1) 
#     
CI.l <- quantile(sim, prob=0.025) ; CI.u <- quantile(sim, prob=0.925) 
#    
if (w.plot == 1)  { plot(hist(sim), col="gray80") ; abline(v= emp, lty=3,col=2,lwd=2) }
return(t(CI))}
#------------------------------------
# ,    
#  : boots -    ,    
#  		empar  - ,     
BootRes <- function(boots,empar, w.plot = 0) {
if (w.plot == 1)    hist(boots)  #  
#      t-.    . 
   bias <- mean(boots) - empar; tc <- qt(0.975, length(boots)-1) ; 
CI <-  as.matrix(rep(NA, 7)) ; colnames(CI) <- ""
rownames(CI) <- c(".","","","CI t","CI t","CI ", "CI ")
 CI[1] <-  empar ;   CI[2] <- bias ;   CI[3] <- sqrt(var(boots))
#      t-
  CI[4] <- empar - bias - tc* CI[3] ;  CI[5] <- empar - bias + tc* CI[3]
#     
  CI[6] <- quantile(boots, prob=0.025);   CI[7] <- quantile(boots, prob=0.975)
  return(t(CI))}
